"""empty message

Revision ID: 75ace1b8b1e0
Revises: 
Create Date: 2018-11-04 18:40:37.722652

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '75ace1b8b1e0'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('background_question',
    sa.Column('idbackground_question', sa.Integer(), nullable=False),
    sa.Column('background_question', sa.String(length=120), nullable=True),
    sa.Column('experiment_idexperiment', sa.Integer(), nullable=True),
    sa.PrimaryKeyConstraint('idbackground_question')
    )
    op.create_table('experiment',
    sa.Column('idexperiment', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=120), nullable=True),
    sa.Column('instruction', sa.String(length=120), nullable=True),
    sa.Column('directoryname', sa.String(length=120), nullable=True),
    sa.Column('language', sa.String(length=120), nullable=True),
    sa.Column('status', sa.String(length=120), nullable=True),
    sa.Column('randomization', sa.String(length=120), nullable=True),
    sa.PrimaryKeyConstraint('idexperiment')
    )
    op.create_index(op.f('ix_experiment_directoryname'), 'experiment', ['directoryname'], unique=True)
    op.create_index(op.f('ix_experiment_instruction'), 'experiment', ['instruction'], unique=False)
    op.create_index(op.f('ix_experiment_name'), 'experiment', ['name'], unique=False)
    op.create_table('trial_randomization',
    sa.Column('idtrial_randomization', sa.Integer(), nullable=False),
    sa.Column('page_idpage', sa.Integer(), nullable=True),
    sa.Column('randomized_idpage', sa.Integer(), nullable=True),
    sa.Column('answer_set_idanswer_set', sa.Integer(), nullable=True),
    sa.Column('experiment_idexperiment', sa.Integer(), nullable=True),
    sa.PrimaryKeyConstraint('idtrial_randomization')
    )
    op.create_table('user',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('username', sa.String(length=64), nullable=True),
    sa.Column('email', sa.String(length=120), nullable=True),
    sa.Column('password_hash', sa.String(length=128), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_user_email'), 'user', ['email'], unique=True)
    op.create_index(op.f('ix_user_username'), 'user', ['username'], unique=True)
    op.create_table('answer_set',
    sa.Column('idanswer_set', sa.Integer(), nullable=False),
    sa.Column('experiment_idexperiment', sa.Integer(), nullable=True),
    sa.Column('session', sa.String(length=120), nullable=True),
    sa.Column('agreement', sa.String(length=120), nullable=True),
    sa.Column('answer_counter', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['experiment_idexperiment'], ['experiment.idexperiment'], ),
    sa.PrimaryKeyConstraint('idanswer_set')
    )
    op.create_table('background_question_option',
    sa.Column('idbackground_question_option', sa.Integer(), nullable=False),
    sa.Column('background_question_idbackground_question', sa.Integer(), nullable=True),
    sa.Column('option', sa.String(length=120), nullable=True),
    sa.ForeignKeyConstraint(['background_question_idbackground_question'], ['background_question.idbackground_question'], ),
    sa.PrimaryKeyConstraint('idbackground_question_option')
    )
    op.create_table('page',
    sa.Column('idpage', sa.Integer(), nullable=False),
    sa.Column('experiment_idexperiment', sa.Integer(), nullable=True),
    sa.Column('type', sa.String(length=120), nullable=True),
    sa.Column('text', sa.String(length=120), nullable=True),
    sa.Column('media', sa.String(length=120), nullable=True),
    sa.ForeignKeyConstraint(['experiment_idexperiment'], ['experiment.idexperiment'], ),
    sa.PrimaryKeyConstraint('idpage')
    )
    op.create_index(op.f('ix_page_media'), 'page', ['media'], unique=False)
    op.create_index(op.f('ix_page_text'), 'page', ['text'], unique=False)
    op.create_index(op.f('ix_page_type'), 'page', ['type'], unique=False)
    op.create_table('question',
    sa.Column('idquestion', sa.Integer(), nullable=False),
    sa.Column('experiment_idexperiment', sa.Integer(), nullable=True),
    sa.Column('question', sa.String(length=120), nullable=True),
    sa.Column('left', sa.String(length=120), nullable=True),
    sa.Column('right', sa.String(length=120), nullable=True),
    sa.ForeignKeyConstraint(['experiment_idexperiment'], ['experiment.idexperiment'], ),
    sa.PrimaryKeyConstraint('idquestion')
    )
    op.create_table('answer',
    sa.Column('idanswer', sa.Integer(), nullable=False),
    sa.Column('question_idquestion', sa.Integer(), nullable=True),
    sa.Column('answer_set_idanswer_set', sa.Integer(), nullable=True),
    sa.Column('answer', sa.String(length=120), nullable=True),
    sa.Column('page_idpage', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['answer_set_idanswer_set'], ['answer_set.idanswer_set'], ),
    sa.ForeignKeyConstraint(['page_idpage'], ['page.idpage'], ),
    sa.ForeignKeyConstraint(['question_idquestion'], ['question.idquestion'], ),
    sa.PrimaryKeyConstraint('idanswer')
    )
    op.create_table('background_question_answer',
    sa.Column('idbackground_question_answer', sa.Integer(), nullable=False),
    sa.Column('answer_set_idanswer_set', sa.Integer(), nullable=True),
    sa.Column('answer', sa.String(length=120), nullable=True),
    sa.Column('background_question_idbackground_question', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['answer_set_idanswer_set'], ['answer_set.idanswer_set'], ),
    sa.ForeignKeyConstraint(['background_question_idbackground_question'], ['background_question.idbackground_question'], ),
    sa.PrimaryKeyConstraint('idbackground_question_answer')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('background_question_answer')
    op.drop_table('answer')
    op.drop_table('question')
    op.drop_index(op.f('ix_page_type'), table_name='page')
    op.drop_index(op.f('ix_page_text'), table_name='page')
    op.drop_index(op.f('ix_page_media'), table_name='page')
    op.drop_table('page')
    op.drop_table('background_question_option')
    op.drop_table('answer_set')
    op.drop_index(op.f('ix_user_username'), table_name='user')
    op.drop_index(op.f('ix_user_email'), table_name='user')
    op.drop_table('user')
    op.drop_table('trial_randomization')
    op.drop_index(op.f('ix_experiment_name'), table_name='experiment')
    op.drop_index(op.f('ix_experiment_instruction'), table_name='experiment')
    op.drop_index(op.f('ix_experiment_directoryname'), table_name='experiment')
    op.drop_table('experiment')
    op.drop_table('background_question')
    # ### end Alembic commands ###
